diff -uNr unrar/archive.cpp unrar/archive.cpp
--- unrar/archive.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/archive.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -57,7 +57,7 @@
   if (!IsArchive(EnableBroken))
   {
     Log(FileName,St(MBadArc),FileName);
-    ErrHandler.Exit(RAR_FATAL_ERROR);
+    ErrHandler.Exit(FATAL_ERROR);
   }
 }
 #endif
@@ -186,7 +186,7 @@
 #ifdef RARDLL
     Cmd->DllError=ERAR_UNKNOWN_FORMAT;
 #else
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
   #if !defined(SILENT) && !defined(SFX_MODULE)
       Log(FileName,St(MUnknownMeth),FileName);
       Log(FileName,St(MVerRequired),NewMhd.EncryptVer/10,NewMhd.EncryptVer%10);
diff -uNr unrar/archive.hpp unrar/archive.hpp
--- unrar/archive.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/archive.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -14,7 +14,6 @@
     void ConvertNameCase(wchar *Name);
     void ConvertUnknownHeader();
     int ReadOldHeader();
-    void PrepareExtraTime(FileHeader *hd,EXTTIME_MODE etm,EXTTIME_MODE etc,EXTTIME_MODE eta,EXTTIME_MODE etarc,Array<byte> &TimeData);
 
 #if !defined(SHELL_EXT) && !defined(NOCRYPT)
     CryptData HeadersCrypt;
diff -uNr unrar/arcread.cpp unrar/arcread.cpp
--- unrar/arcread.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/arcread.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -52,17 +52,17 @@
     if (*Cmd->Password==0)
 #ifdef RARDLL
       if (Cmd->Callback==NULL ||
-          Cmd->Callback(UCM_NEEDPASSWORD,Cmd->UserData,(LONG)Cmd->Password,sizeof(Cmd->Password))==-1)
+          Cmd->Callback(UCM_NEEDPASSWORD,Cmd->UserData,(LPARAM)Cmd->Password,sizeof(Cmd->Password))==-1)
       {
         Close();
-        ErrHandler.Exit(RAR_USER_BREAK);
+        ErrHandler.Exit(USER_BREAK);
       }
 
 #else
       if (!GetPassword(PASSWORD_ARCHIVE,FileName,Cmd->Password,sizeof(Cmd->Password)))
       {
         Close();
-        ErrHandler.Exit(RAR_USER_BREAK);
+        ErrHandler.Exit(USER_BREAK);
       }
 #endif
     HeadersCrypt.SetCryptKeys(Cmd->Password,HeadersSalt,false,false,NewMhd.EncryptVer>=36);
@@ -79,7 +79,7 @@
   #ifndef SHELL_EXT
       Log(FileName,St(MLogUnexpEOF));
   #endif
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
     }
     return(0);
   }
@@ -96,7 +96,7 @@
     Log(FileName,St(MLogFileHead),"???");
 #endif
     BrokenFileHeader=true;
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return(0);
   }
 
@@ -261,7 +261,7 @@
           if (hd->HeadType==NEWSUB_HEAD)
             strcat(hd->FileName,"- ???");
           BrokenFileHeader=true;
-          ErrHandler.SetErrorCode(RAR_WARNING);
+          ErrHandler.SetErrorCode(WARNING);
 #ifndef SHELL_EXT
           Log(Archive::FileName,St(MLogFileHead),IntNameToExt(hd->FileName));
           Alarm();
@@ -370,6 +370,8 @@
       bool Recovered=false;
       if (ShortBlock.HeadType==ENDARC_HEAD && (EndArcHead.Flags & EARC_REVSPACE)!=0)
       {
+        // Last 7 bytes of recovered volume can contain zeroes, because
+        // REV files store its own information (volume number, etc.) here.
         SaveFilePos SavePos(*this);
         Int64 Length=Tell();
         Seek(Length-7,SEEK_SET);
@@ -386,9 +388,9 @@
         Close();
 
         BrokenFileHeader=true;
-        ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+        ErrHandler.SetErrorCode(CRC_ERROR);
         return(0);
-//        ErrHandler.Exit(RAR_CRC_ERROR);
+//        ErrHandler.Exit(CRC_ERROR);
       }
     }
   }
@@ -399,7 +401,7 @@
     Log(FileName,St(MLogFileHead),"???");
 #endif
     BrokenFileHeader=true;
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return(0);
   }
   return(Raw.Size());
@@ -582,10 +584,34 @@
     if ((byte)*s<32 || (byte)*s>127)
       *s='_';
 #endif
+
+#if defined(_WIN_32) || defined(_EMX)
+    // ':' in file names is allowed in Unix, but not in Windows.
+    // Even worse, file data will be written to NTFS stream on NTFS,
+    // so automatic name correction on file create error in extraction 
+    // routine does not work. In Windows and DOS versions we better 
+    // replace ':' now.
+    if (*s==':')
+      *s='_';
+#endif
+
   }
+
   for (wchar *s=NewLhd.FileNameW;*s!=0;s++)
+  {
     if (*s=='/' || *s=='\\')
       *s=CPATHDIVIDER;
+
+#if defined(_WIN_32) || defined(_EMX)
+    // ':' in file names is allowed in Unix, but not in Windows.
+    // Even worse, file data will be written to NTFS stream on NTFS,
+    // so automatic name correction on file create error in extraction 
+    // routine does not work. In Windows and DOS versions we better 
+    // replace ':' now.
+    if (*s==':')
+      *s='_';
+#endif
+  }
 }
 
 
@@ -597,7 +623,7 @@
 #ifndef SHELL_EXT
     Log(FileName,St(MSubHeadCorrupt));
 #endif
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return(false);
   }
   if (SubHead.Method<0x30 || SubHead.Method>0x35 || SubHead.UnpVer>/*PACK_VER*/36)
@@ -643,7 +669,7 @@
 #ifndef SHELL_EXT
     Log(FileName,St(MSubHeadDataCRC),SubHead.FileName);
 #endif
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     if (UnpData!=NULL)
       UnpData->Reset();
     return(false);
diff -uNr unrar/beosea.cpp unrar/beosea.cpp
--- unrar/beosea.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/beosea.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -5,7 +5,7 @@
   if (Arc.HeaderCRC!=Arc.EAHead.HeadCRC)
   {
     Log(Arc.FileName,St(MEABroken),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
   if (Arc.EAHead.Method<0x31 || Arc.EAHead.Method>0x35 || Arc.EAHead.UnpVer>PACK_VER)
@@ -29,14 +29,14 @@
   if (Arc.EAHead.EACRC!=~DataIO.UnpFileCRC)
   {
     Log(Arc.FileName,St(MEABroken),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
   int fd = open(FileName,O_WRONLY);
   if (fd==-1)
   {
     Log(Arc.FileName,St(MCannotSetEA),FileName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
     return;
   }
 
@@ -51,7 +51,7 @@
     if (NameSize>=sizeof(Name))
     {
       Log(Arc.FileName,St(MCannotSetEA),FileName);
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
       break;
     }
     memcpy(Name,CurItem+10,NameSize);
@@ -59,7 +59,7 @@
     if (fs_write_attr(fd,Name,Type,0,CurItem+10+NameSize,Size)==-1)
     {
       Log(Arc.FileName,St(MCannotSetEA),FileName);
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
       break;
     }
     AttrPos+=10+NameSize+Size;
@@ -79,7 +79,7 @@
   if (fd==-1)
   {
     Log(Arc.FileName,St(MCannotSetEA),FileName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
     return;
   }
 
@@ -94,7 +94,7 @@
     if (NameSize>=sizeof(Name))
     {
       Log(Arc.FileName,St(MCannotSetEA),FileName);
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
       break;
     }
     memcpy(Name,CurItem+10,NameSize);
@@ -102,7 +102,7 @@
     if (fs_write_attr(fd,Name,Type,0,CurItem+10+NameSize,Size)==-1)
     {
       Log(Arc.FileName,St(MCannotSetEA),FileName);
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
       break;
     }
     AttrPos+=10+NameSize+Size;
diff -uNr unrar/cmddata.cpp unrar/cmddata.cpp
--- unrar/cmddata.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/cmddata.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -51,7 +51,7 @@
     if (Arg[1]=='-')
       NoMoreSwitches=true;
     else
-      ProcessSwitch(&Arg[1]);
+      ProcessSwitch(&Arg[1],(ArgW!=NULL && *ArgW!=0 ? &ArgW[1]:NULL));
   else
     if (*Command==0)
     {
@@ -81,8 +81,8 @@
       }
       else
       {
-        int Length=strlen(Arg);
-        char EndChar=Arg[Length-1];
+        size_t Length=strlen(Arg);
+        char EndChar=Length==0 ? 0:Arg[Length-1];
         char CmdChar=etoupper(*Command);
         bool Add=strchr("AFUM",CmdChar)!=NULL;
         bool Extract=CmdChar=='X' || CmdChar=='E';
@@ -113,7 +113,7 @@
                 Charset=RCH_OEM;
 #endif
 
-              ReadTextFile(Arg+1,FileArgs,false,true,Charset,true,true);
+              ReadTextFile(Arg+1,FileArgs,false,true,Charset,true,true,true);
             }
             else
               if (Found && FileData.IsDir && Extract && *ExtrPath==0)
@@ -226,7 +226,7 @@
 
 
 #if !defined(SFX_MODULE)
-void CommandData::ProcessSwitch(char *Switch)
+void CommandData::ProcessSwitch(char *Switch,wchar *SwitchW)
 {
 
   switch(etoupper(Switch[0]))
@@ -375,6 +375,8 @@
           break;
         case 'P':
           strcpy(ArcPath,Switch+2);
+          if (SwitchW!=NULL && *SwitchW!=0)
+            strcpyw(ArcPathW,SwitchW+2);
           break;
         case 'S':
           SyncFiles=true;
@@ -408,6 +410,9 @@
         case '-':
           Overwrite=OVERWRITE_NONE;
           break;
+        case 0:
+          Overwrite=OVERWRITE_FORCE_ASK;
+          break;
         case 'R':
           Overwrite=OVERWRITE_AUTORENAME;
           break;
@@ -480,7 +485,7 @@
             Charset=RCH_OEM;
 #endif
 
-          ReadTextFile(Switch+2,Args,false,true,Charset,true,true);
+          ReadTextFile(Switch+2,Args,false,true,Charset,true,true,true);
         }
         else
           Args->AddString(Switch+1);
@@ -794,7 +799,7 @@
             break;
           case 'C':
             {
-              RAR_CHARSET rch;
+              RAR_CHARSET rch=RCH_DEFAULT;
               switch(etoupper(Switch[2]))
               {
                 case 'A':
@@ -874,7 +879,7 @@
 void CommandData::BadSwitch(char *Switch)
 {
   mprintf(St(MUnknownOption),Switch);
-  ErrHandler.Exit(RAR_USER_ERROR);
+  ErrHandler.Exit(USER_ERROR);
 }
 #endif
 
@@ -908,6 +913,18 @@
 #endif
 
 
+inline bool CmpMSGID(MSGID i1,MSGID i2)
+{
+#ifdef MSGID_INT
+  return(i1==i2);
+#else
+  // If MSGID is const char*, we cannot compare pointers only.
+  // Pointers to different instances of same strings can differ,
+  // so we need to compare complete strings.
+  return(strcmp(i1,i2)==0);
+#endif
+}
+
 void CommandData::OutHelp()
 {
 #if !defined(GUI) && !defined(SILENT)
@@ -916,12 +933,13 @@
 #ifdef SFX_MODULE
     MCHelpCmd,MSHelpCmdE,MSHelpCmdT,MSHelpCmdV
 #elif defined(UNRAR)
-    MUNRARTitle1,MRARTitle2,MCHelpCmd,MCHelpCmdE,MCHelpCmdL,MCHelpCmdP,
-    MCHelpCmdT,MCHelpCmdV,MCHelpCmdX,MCHelpSw,MCHelpSwm,MCHelpSwAC,MCHelpSwAD,
-    MCHelpSwAP,MCHelpSwAVm,MCHelpSwCm,MCHelpSwCFGm,MCHelpSwCL,MCHelpSwCU,
+    MUNRARTitle1,MRARTitle2,MCHelpCmd,MCHelpCmdE,MCHelpCmdL,
+    MCHelpCmdP,MCHelpCmdT,MCHelpCmdV,MCHelpCmdX,MCHelpSw,
+    MCHelpSwm,MCHelpSwAC,MCHelpSwAD,MCHelpSwAP,
+    MCHelpSwCm,MCHelpSwCFGm,MCHelpSwCL,MCHelpSwCU,
     MCHelpSwDH,MCHelpSwEP,MCHelpSwEP3,MCHelpSwF,MCHelpSwIDP,MCHelpSwIERR,
     MCHelpSwINUL,MCHelpSwIOFF,MCHelpSwKB,MCHelpSwN,MCHelpSwNa,MCHelpSwNal,
-    MCHelpSwOp,MCHelpSwOm,MCHelpSwOC,MCHelpSwOR,MCHelpSwOW,MCHelpSwP,
+    MCHelpSwO,MCHelpSwOC,MCHelpSwOR,MCHelpSwOW,MCHelpSwP,
     MCHelpSwPm,MCHelpSwR,MCHelpSwRI,MCHelpSwSL,MCHelpSwSM,MCHelpSwTA,
     MCHelpSwTB,MCHelpSwTN,MCHelpSwTO,MCHelpSwTS,MCHelpSwU,MCHelpSwVUnr,
     MCHelpSwVER,MCHelpSwVP,MCHelpSwX,MCHelpSwXa,MCHelpSwXal,MCHelpSwY
@@ -932,13 +950,13 @@
     MCHelpCmdRN,MCHelpCmdRR,MCHelpCmdRV,MCHelpCmdS,MCHelpCmdT,MCHelpCmdU,
     MCHelpCmdV,MCHelpCmdX,MCHelpSw,MCHelpSwm,MCHelpSwAC,MCHelpSwAD,MCHelpSwAG,
     MCHelpSwAO,MCHelpSwAP,MCHelpSwAS,MCHelpSwAV,MCHelpSwAVm,MCHelpSwCm,
-    MCHelpSwCFGm,MCHelpSwCL,MCHelpSwCU,MCHelpSwDF,MCHelpSwDH,MCHelpSwDS,
-    MCHelpSwEa,MCHelpSwED,MCHelpSwEE,MCHelpSwEN,MCHelpSwEP,MCHelpSwEP1,
-    MCHelpSwEP2,MCHelpSwEP3,MCHelpSwF,MCHelpSwHP,MCHelpSwIDP,
-    MCHelpSwIEML,MCHelpSwIERR,MCHelpSwILOG,MCHelpSwINUL,MCHelpSwIOFF,
-    MCHelpSwISND,MCHelpSwK,MCHelpSwKB,MCHelpSwMn,MCHelpSwMC,MCHelpSwMD,
-    MCHelpSwMS,MCHelpSwMT,MCHelpSwN,MCHelpSwNa,MCHelpSwNal,MCHelpSwOp,
-    MCHelpSwOm,MCHelpSwOC,MCHelpSwOL,MCHelpSwOR,MCHelpSwOS,MCHelpSwOW,
+    MCHelpSwCFGm,MCHelpSwCL,MCHelpSwCU,MCHelpSwDF,MCHelpSwDH,MCHelpSwDR,
+    MCHelpSwDS,MCHelpSwDW,MCHelpSwEa,MCHelpSwED,MCHelpSwEE,MCHelpSwEN,
+    MCHelpSwEP,MCHelpSwEP1,MCHelpSwEP2,MCHelpSwEP3,MCHelpSwF,MCHelpSwHP,
+    MCHelpSwIDP,MCHelpSwIEML,MCHelpSwIERR,MCHelpSwILOG,MCHelpSwINUL,
+    MCHelpSwIOFF,MCHelpSwISND,MCHelpSwK,MCHelpSwKB,MCHelpSwMn,MCHelpSwMC,
+    MCHelpSwMD,MCHelpSwMS,MCHelpSwMT,MCHelpSwN,MCHelpSwNa,MCHelpSwNal,
+    MCHelpSwO,MCHelpSwOC,MCHelpSwOL,MCHelpSwOR,MCHelpSwOS,MCHelpSwOW,
     MCHelpSwP,MCHelpSwPm,MCHelpSwR,MCHelpSwR0,MCHelpSwRI,MCHelpSwRR,
     MCHelpSwRV,MCHelpSwS,MCHelpSwSm,MCHelpSwSC,MCHelpSwSFX,MCHelpSwSI,
     MCHelpSwSL,MCHelpSwSM,MCHelpSwT,MCHelpSwTA,MCHelpSwTB,MCHelpSwTK,
@@ -958,11 +976,11 @@
 #ifndef _WIN_32
     static MSGID Win32Only[]={
       MCHelpSwIEML,MCHelpSwVD,MCHelpSwAO,MCHelpSwOS,MCHelpSwIOFF,
-      MCHelpSwEP2,MCHelpSwOC
+      MCHelpSwEP2,MCHelpSwOC,MCHelpSwDR,MCHelpSwRI
     };
     bool Found=false;
     for (int J=0;J<sizeof(Win32Only)/sizeof(Win32Only[0]);J++)
-      if (Help[I]==Win32Only[J])
+      if (CmpMSGID(Help[I],Win32Only[J]))
       {
         Found=true;
         break;
@@ -971,27 +989,23 @@
       continue;
 #endif
 #if !defined(_UNIX) && !defined(_WIN_32)
-    if (Help[I]==MCHelpSwOW)
+    if (CmpMSGID(Help[I],MCHelpSwOW))
       continue;
 #endif
 #if !defined(_WIN_32) && !defined(_EMX)
-    if (Help[I]==MCHelpSwAC)
+    if (CmpMSGID(Help[I],MCHelpSwAC))
       continue;
 #endif
 #ifndef SAVE_LINKS
-    if (Help[I]==MCHelpSwOL)
-      continue;
-#endif
-#ifndef _WIN_32
-    if (Help[I]==MCHelpSwRI)
+    if (CmpMSGID(Help[I],MCHelpSwOL))
       continue;
 #endif
 #ifndef PACK_SMP
-    if (Help[I]==MCHelpSwMT)
+    if (CmpMSGID(Help[I],MCHelpSwMT))
       continue;
 #endif
 #ifndef _BEOS
-    if (Help[I]==MCHelpSwEE)
+    if (CmpMSGID(Help[I],MCHelpSwEE))
     {
 #if defined(_EMX) && !defined(_DJGPP)
       if (_osmode != OS2_MODE)
@@ -1005,7 +1019,7 @@
     mprintf(St(Help[I]));
   }
   mprintf("\n");
-  ErrHandler.Exit(RAR_USER_ERROR);
+  ErrHandler.Exit(USER_ERROR);
 #endif
 }
 
diff -uNr unrar/cmddata.hpp unrar/cmddata.hpp
--- unrar/cmddata.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/cmddata.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -7,7 +7,7 @@
 {
   private:
     void ProcessSwitchesString(char *Str);
-    void ProcessSwitch(char *Switch);
+    void ProcessSwitch(char *Switch,wchar *SwitchW=NULL);
     void BadSwitch(char *Switch);
     bool ExclCheckArgs(StringList *Args,char *CheckName,bool CheckFullPath,int MatchMode);
     uint GetExclAttr(char *Str);
diff -uNr unrar/consio.cpp unrar/consio.cpp
--- unrar/consio.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/consio.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -4,8 +4,11 @@
 #include "log.cpp"
 #endif
 
+static int KbdAnsi(char *Addr,int Size);
+
 #if !defined(GUI) && !defined(SILENT)
 static void RawPrint(char *Msg,MESSAGE_TYPE MessageType);
+static uint GetKey();
 #endif
 
 static MESSAGE_TYPE MsgStream=MSG_STDOUT;
@@ -133,27 +136,6 @@
 #endif
 
 
-#if !defined(GUI) && !defined(SILENT)
-unsigned int GetKey()
-{
-#ifdef SILENT
-  return(0);
-#else
-  char Str[80];
-#ifdef __GNUC__
-  fgets(Str,sizeof(Str),stdin);
-  return(Str[0]);
-#else
-  File SrcFile;
-  SrcFile.SetHandleType(FILE_HANDLESTD);
-  SrcFile.Read(Str,sizeof(Str));
-  return(Str[0]);
-#endif
-#endif
-}
-#endif
-
-
 #ifndef SILENT
 bool GetPassword(PASSWORD_TYPE Type,const char *FileName,char *Password,int MaxLength)
 {
@@ -199,6 +181,29 @@
 
 
 #if !defined(GUI) && !defined(SILENT)
+uint GetKey()
+{
+  char Str[80];
+  bool EndOfFile;
+#if defined(__GNUC__) || defined(sun)
+  EndOfFile=(fgets(Str,sizeof(Str),stdin)==NULL);
+#else
+  File SrcFile;
+  SrcFile.SetHandleType(FILE_HANDLESTD);
+  EndOfFile=(SrcFile.Read(Str,sizeof(Str))==0);
+#endif
+  if (EndOfFile)
+  {
+    // Looks like stdin is a null device. We can enter to infinite loop
+    // calling Ask(), so let's better exit.
+    ErrHandler.Exit(USER_BREAK);
+  }
+  return(Str[0]);
+}
+#endif
+
+
+#if !defined(GUI) && !defined(SILENT)
 int Ask(const char *AskStr)
 {
   const int MaxItems=10;
diff -uNr unrar/consio.hpp unrar/consio.hpp
--- unrar/consio.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/consio.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -12,12 +12,10 @@
 void eprintf(const char *fmt,...);
 void Alarm();
 void GetPasswordText(char *Str,int MaxLength);
-unsigned int GetKey();
 bool GetPassword(PASSWORD_TYPE Type,const char *FileName,char *Password,int MaxLength);
 int Ask(const char *AskStr);
 #endif
 
-int KbdAnsi(char *Addr,int Size);
 void OutComment(char *Comment,int Size);
 
 #ifdef SILENT
diff -uNr unrar/crc.cpp unrar/crc.cpp
--- unrar/crc.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/crc.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -14,12 +14,18 @@
 }
 
 
-uint CRC(uint StartCRC,const void *Addr,uint Size)
+uint CRC(uint StartCRC,const void *Addr,size_t Size)
 {
   if (CRCTab[1]==0)
     InitCRC();
   byte *Data=(byte *)Addr;
 #if defined(LITTLE_ENDIAN) && defined(PRESENT_INT32) && defined(ALLOW_NOT_ALIGNED_INT)
+
+#ifdef _MSC_VER
+  // avoid a warning about 'Data' pointer truncation in 64 bit mode
+  #pragma warning( disable : 4311 )
+#endif
+
   while (Size>0 && ((long)Data & 7))
   {
     StartCRC=CRCTab[(byte)(StartCRC^Data[0])]^(StartCRC>>8);
@@ -42,16 +48,16 @@
     Size-=8;
   }
 #endif
-  for (int I=0;I<Size;I++)
+  for (size_t I=0;I<Size;I++)
     StartCRC=CRCTab[(byte)(StartCRC^Data[I])]^(StartCRC>>8);
   return(StartCRC);
 }
 
 #ifndef SFX_MODULE
-ushort OldCRC(ushort StartCRC,const void *Addr,uint Size)
+ushort OldCRC(ushort StartCRC,const void *Addr,size_t Size)
 {
   byte *Data=(byte *)Addr;
-  for (int I=0;I<Size;I++)
+  for (size_t I=0;I<Size;I++)
   {
     StartCRC=(StartCRC+Data[I])&0xffff;
     StartCRC=((StartCRC<<1)|(StartCRC>>15))&0xffff;
diff -uNr unrar/crc.hpp unrar/crc.hpp
--- unrar/crc.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/crc.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -4,7 +4,7 @@
 extern uint CRCTab[256];
 
 void InitCRC();
-uint CRC(uint StartCRC,const void *Addr,uint Size);
-ushort OldCRC(ushort StartCRC,const void *Addr,uint Size);
+uint CRC(uint StartCRC,const void *Addr,size_t Size);
+ushort OldCRC(ushort StartCRC,const void *Addr,size_t Size);
 
 #endif
diff -uNr unrar/dll.cpp unrar/dll.cpp
--- unrar/dll.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/dll.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -221,9 +221,10 @@
   try
   {
     Data->Cmd.DllError=0;
-    if (Data->OpenMode==RAR_OM_LIST || Operation==RAR_SKIP && !Data->Arc.Solid)
+    if (Data->OpenMode==RAR_OM_LIST || Data->OpenMode==RAR_OM_LIST_INCSPLIT ||
+        Operation==RAR_SKIP && !Data->Arc.Solid)
     {
-      if (/*Data->OpenMode==RAR_OM_LIST && */Data->Arc.Volume &&
+      if (Data->Arc.Volume &&
           Data->Arc.GetHeaderType()==FILE_HEAD &&
           (Data->Arc.NewLhd.Flags & LHD_SPLIT_AFTER)!=0)
         if (MergeArchive(Data->Arc,NULL,false,'L'))
@@ -265,6 +266,9 @@
         strncpyw(Data->Cmd.ExtrPathW,NullToEmpty(DestPathW),NM-2);
         AddEndSlash(Data->Cmd.ExtrPathW);
         strncpyw(Data->Cmd.DllDestNameW,NullToEmpty(DestNameW),NM-1);
+
+        if (*Data->Cmd.DllDestNameW!=0 && *Data->Cmd.DllDestName==0)
+          WideToChar(Data->Cmd.DllDestNameW,Data->Cmd.DllDestName);
       }
       else
       {
@@ -312,7 +316,7 @@
 }
 
 
-void PASCAL RARSetCallback(HANDLE hArcData,UNRARCALLBACK Callback,LONG UserData)
+void PASCAL RARSetCallback(HANDLE hArcData,UNRARCALLBACK Callback,LPARAM UserData)
 {
   DataSet *Data=(DataSet *)hArcData;
   Data->Cmd.Callback=Callback;
@@ -345,19 +349,19 @@
 {
   switch(ErrCode)
   {
-    case RAR_FATAL_ERROR:
+    case FATAL_ERROR:
       return(ERAR_EREAD);
-    case RAR_CRC_ERROR:
+    case CRC_ERROR:
       return(ERAR_BAD_DATA);
-    case RAR_WRITE_ERROR:
+    case WRITE_ERROR:
       return(ERAR_EWRITE);
-    case RAR_OPEN_ERROR:
+    case OPEN_ERROR:
       return(ERAR_EOPEN);
-    case RAR_CREATE_ERROR:
+    case CREATE_ERROR:
       return(ERAR_ECREATE);
-    case RAR_MEMORY_ERROR:
+    case MEMORY_ERROR:
       return(ERAR_NO_MEMORY);
-    case RAR_SUCCESS:
+    case SUCCESS:
       return(0);
     default:
       return(ERAR_UNKNOWN);
diff -uNr unrar/dll.hpp unrar/dll.hpp
--- unrar/dll.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/dll.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -15,8 +15,9 @@
 #define ERAR_UNKNOWN            21
 #define ERAR_MISSING_PASSWORD   22
 
-#define RAR_OM_LIST           0
-#define RAR_OM_EXTRACT        1
+#define RAR_OM_LIST              0
+#define RAR_OM_EXTRACT           1
+#define RAR_OM_LIST_INCSPLIT     2
 
 #define RAR_SKIP              0
 #define RAR_TEST              1
@@ -32,6 +33,7 @@
 #define PASCAL
 #define LONG long
 #define HANDLE void *
+#define LPARAM long
 #define UINT unsigned int
 #endif
 
@@ -109,7 +111,7 @@
   UCM_CHANGEVOLUME,UCM_PROCESSDATA,UCM_NEEDPASSWORD
 };
 
-typedef int (CALLBACK *UNRARCALLBACK)(UINT msg,LONG UserData,LONG P1,LONG P2);
+typedef int (CALLBACK *UNRARCALLBACK)(UINT msg,LPARAM UserData,LPARAM P1,LPARAM P2);
 
 typedef int (PASCAL *CHANGEVOLPROC)(char *ArcName,int Mode);
 typedef int (PASCAL *PROCESSDATAPROC)(unsigned char *Addr,int Size);
@@ -125,7 +127,7 @@
 int    PASCAL RARReadHeaderEx(HANDLE hArcData,struct RARHeaderDataEx *HeaderData);
 int    PASCAL RARProcessFile(HANDLE hArcData,int Operation,char *DestPath,char *DestName);
 int    PASCAL RARProcessFileW(HANDLE hArcData,int Operation,wchar_t *DestPath,wchar_t *DestName);
-void   PASCAL RARSetCallback(HANDLE hArcData,UNRARCALLBACK Callback,LONG UserData);
+void   PASCAL RARSetCallback(HANDLE hArcData,UNRARCALLBACK Callback,LPARAM UserData);
 void   PASCAL RARSetChangeVolProc(HANDLE hArcData,CHANGEVOLPROC ChangeVolProc);
 void   PASCAL RARSetProcessDataProc(HANDLE hArcData,PROCESSDATAPROC ProcessDataProc);
 void   PASCAL RARSetPassword(HANDLE hArcData,char *Password);
diff -uNr unrar/errhnd.cpp unrar/errhnd.cpp
--- unrar/errhnd.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/errhnd.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -11,7 +11,7 @@
 
 void ErrorHandler::Clean()
 {
-  ExitCode=RAR_SUCCESS;
+  ExitCode=SUCCESS;
   ErrCount=0;
   EnableBreak=true;
   Silent=false;
@@ -22,7 +22,7 @@
 void ErrorHandler::MemoryError()
 {
   MemoryErrorMsg();
-  Throw(RAR_MEMORY_ERROR);
+  Throw(MEMORY_ERROR);
 }
 
 
@@ -30,7 +30,7 @@
 {
 #ifndef SILENT
   OpenErrorMsg(FileName);
-  Throw(RAR_OPEN_ERROR);
+  Throw(OPEN_ERROR);
 #endif
 }
 
@@ -45,7 +45,7 @@
   }
 #endif
 #if !defined(SILENT) || defined(RARDLL)
-  Throw(RAR_FATAL_ERROR);
+  Throw(FATAL_ERROR);
 #endif
 }
 
@@ -56,7 +56,7 @@
   ReadErrorMsg(NULL,FileName);
 #endif
 #if !defined(SILENT) || defined(RARDLL)
-  Throw(RAR_FATAL_ERROR);
+  Throw(FATAL_ERROR);
 #endif
 }
 
@@ -81,7 +81,7 @@
   WriteErrorMsg(ArcName,FileName);
 #endif
 #if !defined(SILENT) || defined(RARDLL)
-  Throw(RAR_WRITE_ERROR);
+  Throw(WRITE_ERROR);
 #endif
 }
 
@@ -94,7 +94,7 @@
   ErrMsg(NULL,St(MNTFSRequired),FileName);
 #endif
 #if !defined(SILENT) && !defined(SFX_MODULE) || defined(RARDLL)
-  Throw(RAR_WRITE_ERROR);
+  Throw(WRITE_ERROR);
 #endif
 }
 #endif
@@ -124,7 +124,7 @@
   }
 #endif
 #if !defined(SILENT) || defined(RARDLL)
-  Throw(RAR_FATAL_ERROR);
+  Throw(FATAL_ERROR);
 #endif
 }
 
@@ -247,14 +247,14 @@
 {
   switch(Code)
   {
-    case RAR_WARNING:
-    case RAR_USER_BREAK:
-      if (ExitCode==RAR_SUCCESS)
+    case WARNING:
+    case USER_BREAK:
+      if (ExitCode==SUCCESS)
         ExitCode=Code;
       break;
-    case RAR_FATAL_ERROR:
-      if (ExitCode==RAR_SUCCESS || ExitCode==RAR_WARNING)
-        ExitCode=RAR_FATAL_ERROR;
+    case FATAL_ERROR:
+      if (ExitCode==SUCCESS || ExitCode==WARNING)
+        ExitCode=FATAL_ERROR;
       break;
     default:
       ExitCode=Code;
@@ -289,8 +289,9 @@
 #if defined(USE_RC) && !defined(SFX_MODULE) && !defined(_WIN_CE)
   ExtRes.UnloadDLL();
 #endif
-  exit(RAR_USER_BREAK);
-#ifdef _WIN_32
+  exit(USER_BREAK);
+#if defined(_WIN_32) && !defined(_MSC_VER)
+  // never reached, just to avoid a compiler warning
   return(TRUE);
 #endif
 }
@@ -314,7 +315,7 @@
 
 void ErrorHandler::Throw(int Code)
 {
-  if (Code==RAR_USER_BREAK && !EnableBreak)
+  if (Code==USER_BREAK && !EnableBreak)
     return;
   ErrHandler.SetErrorCode(Code);
 #ifdef ALLOW_EXCEPTIONS
diff -uNr unrar/errhnd.hpp unrar/errhnd.hpp
--- unrar/errhnd.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/errhnd.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -12,11 +12,12 @@
 #define rarrealloc realloc
 #define rarfree free
 #define rarstrdup strdup
+#define rarstrdupw strdupw
 
 
 
-enum { RAR_SUCCESS,RAR_WARNING,RAR_FATAL_ERROR,RAR_CRC_ERROR,RAR_LOCK_ERROR,RAR_WRITE_ERROR,
-       RAR_OPEN_ERROR,RAR_USER_ERROR,RAR_MEMORY_ERROR,RAR_CREATE_ERROR,RAR_USER_BREAK=255};
+enum { SUCCESS,WARNING,FATAL_ERROR,CRC_ERROR,LOCK_ERROR,WRITE_ERROR,
+       OPEN_ERROR,USER_ERROR,MEMORY_ERROR,CREATE_ERROR,USER_BREAK=255};
 
 class ErrorHandler
 {
